=== debian/changelog ===
pgloader (3.6.10-5) unstable; urgency=medium

  * Bump ip4r dependencies to 18.
  * debian/rules: Remove version number sanity checks, should be done
    upstream.

 -- Christoph Berg <myon@debian.org>  Sun, 26 Oct 2025 13:59:14 +0100

pgloader (3.6.10-4) unstable; urgency=medium

  * Build- and Test-Depend on postgresql-17-ip4r. (Closes: #1082693)
  * Move packaging repository to salsa.debian.org.

 -- Christoph Berg <myon@debian.org>  Mon, 28 Oct 2024 11:44:35 +0100

pgloader (3.6.10-3) unstable; urgency=medium

  * Drop 32-bit architectures, cl-ironclad is reported to be unstable there.
    (Closes: #1077220)

 -- Christoph Berg <myon@debian.org>  Sat, 27 Jul 2024 10:23:33 +0300

pgloader (3.6.10-2) unstable; urgency=medium

  * Limit architectures to those that have sbcl available and working thread
    support (notably, this excludes armel and armhf).

 -- Christoph Berg <myon@debian.org>  Fri, 22 Mar 2024 14:59:27 +0100

pgloader (3.6.10-1) unstable; urgency=medium

  * New upstream version.
  * Bump ip4r dependencies to 16. (Closes: #1052837)

 -- Christoph Berg <myon@debian.org>  Thu, 02 Nov 2023 17:44:07 +0100
