=== debian/tests/control ===
Depends:
 ca-certificates,
 cl-postmodern,
 pgloader,
 postgresql,
Tests: ssl
Restrictions: allow-stderr, needs-root

Depends:
 pgloader,
 postgresql-18-ip4r | postgresql-ip4r,
Tests: testsuite
Restrictions: allow-stderr
