=== debian/watch ===
version=4
https://github.com/dimitri/pgloader/tags .*/v(.*).tar.gz
